<template>
<div id="gameplay-ui">
	<div class="timer">{{ Math.ceil(time) }}</div>
	<!--
	<div class="players red">
		<div class="title">RED</div>
		<div
			class="player"
			v-for="player in players.RED"
			:key="player.name"
		>
			{{ player.name }} {{ player.powerup ? "- " + player.powerup: "" }}
		</div>
	</div>
	<div class="players blue">
		<div class="title">BLUE</div>
		<div
			class="player"
			v-for="player in players.BLUE"
			:key="player.name"
		>
			{{ player.name }} {{ player.powerup ? "- " + player.powerup: "" }}
		</div>
	</div>
	-->
</div>
</template>

<script>
import {
	EVENT_GP_UPDATE_PLAYERS,
	EVENT_GP_UPDATE_TIMER,
} from "../../constants/ui.js"

export default {
	beforeDestroy () {
		UI.off(EVENT_GP_UPDATE_PLAYERS, this.updatePlayerData)
		UI.off(EVENT_GP_UPDATE_TIMER, this.updateTimer)
	},
	data () {
		return {
			players: {
				BLUE: [],
				RED: [],
				UNDECIDED: [],
			},
			time: 0
		}
	},
	methods: {
		updatePlayerData (players) {
			const BLUE = []
			const RED = []
			const UNDECIDED = []

			players.forEach((player) => {
				if (player.alignment === "BLUE") BLUE.push(player)
				else if (player.alignment === "RED") RED.push(player)
				else UNDECIDED.push(player)
			})

			this.players.BLUE = BLUE
			this.players.RED = RED
			this.players.UNDECIDED = UNDECIDED
		},
		updateTimer (time) {
			this.time = time
		}
	},
	mounted () {
		UI.on(EVENT_GP_UPDATE_PLAYERS, this.updatePlayerData)
		UI.on(EVENT_GP_UPDATE_TIMER, this.updateTimer)
	},
	name: "gameplay"
}
</script>

<style lang="less" scoped>
#gameplay-ui {
	bottom: 0;
	color: #fff;
	font-size: 4em;
	left: 0;
	position: absolute;
	right: 0;
	top: 0;
}

.players {
	bottom: 1em;
	font-size: .75em;
	position: absolute;

	&.blue {
		right: 1em;
		text-align: right;

		.title {
			color: #55f;
		}
	}

	&.red {
		left: 1em;

		.title {
			color: #f55;
		}
	}
}

.timer {
	font-size: 1.25em;
	left: 0;
	position: absolute;
	right: 0;
	text-align: center;
	top: 1em;
}
</style>
